<?xml version="1.0" encoding="UTF-8"?>
<!--	2012-03-06	0.1	Robert Melskens	M.b.v. dit stylesheet worden de StUF schema's van een sectormodel omgezet zodat deze
																wel bruikbaar zijn in bepaalde software pakketten

																Voor een correcte werking van dit stylesheet moet het opgestart worden vanuit het configuratie 
																bestand.

																Het moge duidelijk zijn dat de inhoud en de verwijzingen in alle van het sectormodel deel 
																uitmakende XML schema's
																eveneens correct moeten zijn om tot het juiste resultaat te komen.

																In dit stylesheet en ook in de resulterende tussenresultaten worden elementen gegenereerd 
																binnen de XML-Schema namespace die daar eigenlijk niet toe behoren.
																De tussenresultaten mogen dan ook niet als valide XML-Schema's beschouwd worden en 
																kunnen dus ook niet worden gevalideerd. 

																Het proces bestaat uit 2 stappen. Als eerste wordt, startend vanuit het rootschema dat in het 
																configuratiebestand is gedefinieerd, per namespace een lijst gegenereerd van schema's die 
																deel uitmaken van die namespace en schema's die daarin geimporteerd worden.
																Daarna worden op basis van die lijst per namespace een schema gegenereerd. Daarbij worden 
																afhankelijk van de waarde van de variabele 'restrictionMode' restriction complexTypes verwerkt 
																tot normale complexTypes.
		2012-05-03	0.2	Robert Melskens	Stylesheet genereert nu schema's waarin de XML-schema elementen geen prefix hebben. 
																Daarnaast werden de attributen bij de compelxTypes in versie 0.1 nog niet correct geresolved 
																en hadden de 'import' elementen nog het ongewenste 'xmlns' attribuut. Dit is nu gecorrigeerd. 
		2012-05-08	0.3	Robert Melskens	Stylesheet resolved nu ook complexTypes met simpleContent met dien verstande dat dit alleen 
																gebeurd daar waar het complexType of diens voorouders (tot aan de eerste voorouder met een 
																'extension' element) alleen attributes definieren. 
																Ook worden nu attributeGroup elementen binnen attributeGroup elementen geresolved en alle 
																'...-basis' complexTypes die niet meer in gebruik zijn eruit gefilterd. 
		2012-05-11	0.4	Robert Melskens	Templates opgeschoond en een aantal daarvan geintegreerd met elkaar.
																Tijdens het genereren worden nu status berichten gegenereerd.
																Tenslotte de performance verbeterd door gebruik te maken van 'xsl:key' constructies. -->

<!--	LET OP! 											In een import of een include kan af en toe naar een http adres verwezen worden. Zo'n adres is 
																eigenlijk niet te resolven naar een lokaal adres. 
																Bij een import zou je er voor kunnen kiezen deze verwijzing gewoon te laten staan (dus niet 
																transformeren naar een absoluut lokaal adres). 
																Bij een include kan dat dus niet en dan zal de inhoud van het schema waarnaar verwezen wordt 
																gewoon binnengehaald moeten worden. 
																Een andere optie is dit soort verwijzingen niet te accepteren voor deze applicatie. Dat zou echter 
																betekenen dat in een StUF taxonomy geen http verwijzingen opgenomen mogen worden. -->	

<xsl:stylesheet exclude-result-prefixes="fn schemaReferences application xs xsd" version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/2001/XMLSchema" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2005/xpath-functions" xmlns:application="http://www.kinggemeenten.nl/2011/applicationConfiguration" xmlns:schemaReferences="http://www.kinggemeenten.nl/2011/schemaReferences" >

	<xsl:output method="xml" indent="yes" encoding="utf-8" exclude-result-prefixes="fn schemaReferences application xs xsd" />
	<xsl:param name="restrictionMode" select="//application:restrictionMode"/>
	<xsl:param name="debug" select="'no'"/>
	
	<xsl:key name="complexType" match="//xs:schema/xs:complexType" use=".//xs:element/substring-after(@type,':')"/>
	<xsl:key name="complexTypeWithStop" match="xs:complexType[.//xs:stop]" use="concat(@name,@namespace)"/>
	<xsl:key name="complexTypeWithoutStop" match="xs:complexType[not(.//xs:stop)]" use="concat(@name,@namespace)"/>
	
	<xsl:variable name="applicationPath" select="replace(//application:path,'\\','/')"/>
	<xsl:variable name="doNotResolve">
		<application:doNotResolve>
			<xsl:copy-of select="//application:doNotResolve" exclude-result-prefixes="xs xsd"/>
		</application:doNotResolve>
	</xsl:variable>
	
	<!--Root van het configuratie bestand dient als vertrekpunt voor dit stylesheet. -->

	<xsl:template match="/" exclude-result-prefixes="xs xsd">
		<xsl:apply-templates select="//application:configurationSectorModel[@active='yes'][1]"/>
	</xsl:template>
	
	<xsl:template match="application:configurationSectorModel" exclude-result-prefixes="xs xsd">
		<xsl:call-template name="startConversion">
			<xsl:with-param name="schemaPath" select="concat(replace(application:pathSectormodel,'\\','/'),'/',replace(./application:resolve/application:schema/application:schemaName,'\\','/'))"/>
		</xsl:call-template>
	</xsl:template>
	
	<!-- Het volgende template start de eigenlijke conversie op basis van het in het configuratiebestand gedefinieerde schema (berichtencatalogus). 
		  Dit schema wordt eerst verwerkt tot een XML fragment waarin alleen de imports en includes zijn opgenomen. 
		  Daarna wordt dit schema gebruikt als input voor het verwerken van alle schema's die hierin geimporteerd of geinclude worden. -->
	<xsl:template name="startConversion" exclude-result-prefixes="xs xsd">
		<xsl:param name="schemaPath"/>
<xsl:message>
********************************************************************************<xsl:text>
</xsl:text>Start conversie van de berichtencatalogus <xsl:value-of select="$schemaPath"/>
</xsl:message>		
<xsl:message>
 1. Genereren lijsten met schema's binnen de taxonomie.
</xsl:message>		
		<xsl:variable name="schema" select="document($schemaPath)"/>
		<xsl:variable name="path">
			<xsl:call-template name="extractDirOrFileName">
				<xsl:with-param name="action" select="'extractDir'"/>
				<xsl:with-param name="filePath" select="$schemaPath"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:apply-templates select="$schema/xs:schema" mode="root">
			<xsl:with-param name="path" select="$path"/>
			<xsl:with-param name="schemaPath" select="$schemaPath"/>
		</xsl:apply-templates>
		<xsl:call-template name="nextLoop">
			<xsl:with-param name="path" select="$path"/>
			<xsl:with-param name="currentLoop" select="1"/>
		</xsl:call-template>
<xsl:message>
Einde conversie.<xsl:text>
</xsl:text>********************************************************************************
</xsl:message>		
	</xsl:template>

	<!-- Het onderstaande template verwerkt alle schema's die in een ander schema via een 'xs:import' of 'xs:include' geimporteerd of geinclude worden.
		  Als input voor deze verwerking dient het in de voorgaande loop aangemaakte schemaList bestand ('schemaList_Lp...').-->
	<xsl:template name="nextLoop" exclude-result-prefixes="fn schemaReferences xs xsd">
		<xsl:param name="path"/>
		<xsl:param name="currentLoop"/>
		<xsl:variable name="referenceSet" select="document(concat('file:////',$applicationPath,'/generated/schemaList_Lp',$currentLoop,'.xml'))"/>
		<xsl:choose>
			<!-- Zolang er nog xs:include en xs:import elementen voorkomen die nog niet geprocessed zijn worden deze eerst geprocessed en wordt de 
				  nextLoop template opgestart. 
				  Dit leidt tot nieuwe schemaList ('schemaList_Lp...') en ready ('ready_Lp...') bestanden. -->
			<xsl:when test="($referenceSet//xs:include[not(@processed='yes')] or $referenceSet//xs:import[not(@processed='yes')])">
				<xsl:variable name="loop" select="$currentLoop + 1"/>
				<xsl:result-document href="{concat('file:////',$applicationPath,'/generated/schemaList_Lp',$loop,'.xml')}" indent="yes" method="xml">
					<schema  xmlns="http://www.w3.org/2001/XMLSchema">
						<!-- Volgende apply-templates repliceert alle aanwezige elementen waarbij xs:import en xs:include de indicatie processed='yes' krijgen. -->
						<xsl:apply-templates select="$referenceSet//xs:import
																							[not(preceding-sibling::xs:import
																											[@schemaLocation=current()/@schemaLocation and 
																											 @namespace=current()/@namespace and 
																											 @importingNamespace=current()/@importingNamespace])] | 
																		$referenceSet//xs:include
																							[not(@schemaLocation = preceding-sibling::xs:include/@schemaLocation) and 
																							 not(@schemaLocation = preceding-sibling::xs:import/@schemaLocation)] | 
																		$referenceSet//xs:div | 
																		$referenceSet//xs:rootSchema" mode="indicateProcessed"/>
						<div/>
						<!-- Volgende apply-templates verwerkt alle in de nog niet verwerkte xs:includes en xs:import elementen aangegeven schema's. -->
						<xsl:apply-templates select="$referenceSet//xs:import
																							[not(@processed='yes') and 
																							 not(@schemaLocation = preceding-sibling::xs:import/@schemaLocation)] | 
																   $referenceSet//xs:include
																							[not(@processed='yes') and 
																							 not(@schemaLocation = preceding-sibling::xs:include/@schemaLocation) and 
																							 not(@schemaLocation = preceding-sibling::xs:import/@schemaLocation)]" mode="processIncludes">
						</xsl:apply-templates>
					</schema>
				</xsl:result-document>
				<xsl:result-document href="{concat('file:////',$applicationPath,'/generated/ready_Lp',$loop,'.xml')}" indent="yes" method="xml">
					<ready>yes</ready>
				</xsl:result-document>
				<xsl:call-template name="nextLoop">
					<xsl:with-param name="path" select="$path"/>
					<xsl:with-param name="currentLoop" select="$currentLoop + 1"/>
				</xsl:call-template>
			</xsl:when>
			<!-- Indien alle xs:import en xs:include elementen geprocessed zijn, en er dus een compleet overzicht van alle binnen de taxonomy voorkomende 
				  schema bestanden is, wordt gestart met de uiteindelijke transformatie.
				  Daarvoor wordt eerst het laatste level schemaList bestand ('schemaList_Lp...') zodanig verwerkt dat per namespace alle bijbehorende schema's in een 
				  schemaSet element worden geplaatst. Het resultaat wordt in het finale schemaList bestand geplaatst wat dient als bron voor het produceren van de 
				  per namespace geconsolideerde schema's.
				  Daarmee is de transformatie echter nog niet afgerond aangezien in deze bestanden nog complexTypes aanwezig zijn die niet meer in gebruik zijn,
				  complexTypes waarvan de naam eindigd op '-basis'.
				  De laatste slag bestaat dan ook uit het verwijderen van deze complexTypes. -->
			<xsl:otherwise>
<xsl:message>
 2. Genereren op namespaces gesorteerde lijst met schema's binnen de taxonomie<xsl:text>
</xsl:text>    op basis van voorgaande stap.
</xsl:message>		
				<xsl:result-document href="{concat('file:////',$applicationPath,'/generated/schemaList.xml')}" indent="yes" method="xml">
					<schema  xmlns="http://www.w3.org/2001/XMLSchema">
						<!-- Onderstaande for-each statements zorgen er voor dat eerst een schemaSet element wordt aangemaakt voor de namespace 
							  waarbinnen het rootschema zich bevindt en daarna voor de andere namespaces. -->
						<xsl:for-each select="$referenceSet/xs:schema/*[@namespace=//xs:rootSchema/@namespace and not(@namespace=preceding-sibling::*/@namespace)]">
							<xsl:variable name="namespace" select="@namespace"/>
							<schemaSet namespace="{$namespace}">
								<xsl:for-each select="$referenceSet/xs:schema/*[local-name()!='div' and @namespace=$namespace]">
									<xsl:copy  exclude-result-prefixes="xs xsd">
										<xsl:apply-templates select="@*"/>
									</xsl:copy>
								</xsl:for-each>
							</schemaSet>
						</xsl:for-each>
						<xsl:for-each select="$referenceSet/xs:schema/*[@namespace!=//xs:rootSchema/@namespace and not(@namespace=preceding-sibling::*/@namespace)]">
							<xsl:variable name="namespace" select="@namespace"/>
							<schemaSet namespace="{$namespace}">
								<xsl:for-each select="$referenceSet/xs:schema/*[local-name()!='div' and @namespace=$namespace]">
									<xsl:copy exclude-result-prefixes="xs xsd">
										<xsl:apply-templates select="@*"/>
									</xsl:copy>
								</xsl:for-each>
							</schemaSet>
						</xsl:for-each>
					</schema>
				</xsl:result-document>
				<xsl:result-document href="{concat('file:////',$applicationPath,'/generated/ready.xml')}" indent="yes" method="xml">
					<ready>yes</ready>
				</xsl:result-document>
				<xsl:variable name="completeReferenceSet" select="document(concat('file:////',$applicationPath,'/generated/schemaList.xml'))"/>
				<!-- Hier wordt de generatie van de geconsolideerde schema's opgestart. -->
<xsl:message>
 3. Genereren geconsolideerde schema's.
</xsl:message>		
				<xsl:apply-templates select="$completeReferenceSet//xs:schemaSet" mode="generateSchemas"/>
				<!-- Nu de geconsolideerde schema's zijn gegenereerd kan bepaald worden welke complexTypes niet meer in gebruik zijn zodat deze verwijderd kunnen worden. 
					  Om dit eenvoudig te kunnen doen worden eerst alle geconsolideerde schema's bij elkaar in 1 super consolidatie bestand geplaatst. -->
<xsl:message>
 4. Genereren lijst met recursieve complexType structuren t.b.v. filteren<xsl:text>
</xsl:text>    ongebruikte complexTypes.
</xsl:message>		
				<xsl:variable name="allSchemas">
					<xs:allSchemas>
						<xsl:apply-templates select="$completeReferenceSet//xs:schemaSet" mode="generateConsolidatedSchemaSet"/>
					</xs:allSchemas>
				</xsl:variable>

				<!-- Op basis van het super consolidatie bestand wordt de variabele 'basisComplexTypes' gevuld. 
					  Hiervoor worden alle 'complexType' elementen binnen de 'schema' elementen gecontroleerd. -->
				<xsl:variable name="basisComplexTypes">
					<Basis>
						<xsl:apply-templates select="$allSchemas//xs:schema/xs:complexType[contains(@name,'-basis')]" mode="getPath"/>
					</Basis>
				</xsl:variable>

				<!-- Start: voor debug doeleinden -->
				<xsl:if test="$debug='yes'">
					<xsl:result-document href="{concat('file:////',$applicationPath,'/consolidated/allschemas.xml')}" indent="yes" method="xml">
						<xsl:copy-of select="$allSchemas"/>
					</xsl:result-document>
					<xsl:result-document href="{concat('file:////',$applicationPath,'/consolidated/basisComplexTypes.xml')}" indent="yes" method="xml">
						<xsl:copy-of select="$basisComplexTypes"/>
					</xsl:result-document>
				</xsl:if>
				<!-- Eind: voor debug doeleinden -->
				
				<!-- Tenslotte worden alle schema's in de finalized folder bewaard waarbij de overbodige complexTypes uit het schema verwijderd worden. -->
<xsl:message>
 5. Genereren definitieve schema's zonder ongebruikte complexTypes op basis van<xsl:text>
</xsl:text>    voorgaande stap.
</xsl:message>		
				<xsl:for-each select="$allSchemas//xs:mySchema/xs:schema">
					<xsl:variable name="namespace" select="@targetNamespace"/>
					<xsl:result-document href="{../@path}" indent="yes" method="xml">
						<schema>
							<xsl:for-each select="namespace::*">
								<xsl:if test="local-name()!='xs' and local-name()!='xsd'">
									<xsl:namespace name="{local-name()}" select="."/>
								</xsl:if>
							</xsl:for-each>
							<xsl:apply-templates select="@*"/>
							<xsl:apply-templates select="*[not(local-name()='complexType')]"/>
							<!-- Nog inbouwen dat er gecheckt wordt op basis van de namespace. -->
							<xsl:for-each select="xs:complexType">
								<xsl:variable name="name" select="@name"/>
								<xsl:choose>
									<xsl:when test="$basisComplexTypes/xs:Basis[key('complexTypeWithStop',concat($name,$namespace))]">
											<xsl:copy>
												<xsl:apply-templates select="@*"/>
												<xsl:apply-templates select="*"/>									
											</xsl:copy>
									</xsl:when>
									<xsl:when test="$basisComplexTypes/xs:Basis[key('complexTypeWithoutStop',concat($name,$namespace))]"/>
									<xsl:otherwise>
										<xsl:copy>
											<xsl:apply-templates select="@*"/>
											<xsl:apply-templates select="*"/>									
										</xsl:copy>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:for-each>
						</schema>
					</xsl:result-document>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- Dit template wordt alleen gebruikt voor het verwerken van het rootschema (het schema dat in het configuratie bestand is gedefinieerd).
		  Het maakt eerst een variabele aan die gevuld wordt met een xs:schema element met daarin alleen de in het schema voorkomende 
		  xs:include en xs:import elementen (verrijkt met extra informatie).
		  Daarna worden 2 bestanden aangemaakt, het bestand ('schemaList_Lp...') met de inhoud van deze variabele en een ready bestand ('ready_Lp....') 
		  dat nodig is om het schemaList bestand vrij te geven voor verdere verwerking.
		  Mogelijk kunnen we onderstaande template op een later tijdstip nog samenvoegen met het nextLoop template. -->
	<xsl:template match="xs:schema" mode="root" exclude-result-prefixes="xs xsd">
		<xsl:param name="path"/>
		<xsl:param name="schemaPath"/>
		<xsl:param name="loop" select="1"/>
		<xsl:variable name="schema">
		
			<xsl:copy copy-namespaces="no"  exclude-result-prefixes="xs xsd">
				<rootSchema schemaLocation="{$schemaPath}" namespace="{@targetNamespace}"/>
				<xsl:apply-templates select="xs:import" mode="buildListOfImportsOrIncludes">
					<xsl:with-param name="path" select="$path"/>
				</xsl:apply-templates>
				<xsl:apply-templates select="xs:include" mode="buildListOfImportsOrIncludes">
					<xsl:with-param name="path" select="$path"/>
				</xsl:apply-templates>
			</xsl:copy>
		</xsl:variable>
		<xsl:result-document href="{concat('file:////',$applicationPath,'/generated/schemaList_Lp',$loop,'.xml')}" indent="yes" method="xml">
			<xsl:copy-of select="$schema" exclude-result-prefixes="xs xsd"/>
		</xsl:result-document>
		<xsl:result-document href="{concat('file:////',$applicationPath,'/generated/ready_Lp',$loop,'.xml')}" indent="yes" method="xml">
			<ready>yes</ready>
		</xsl:result-document>
	</xsl:template>
	
	<xsl:template match="xs:schema" mode="include" exclude-result-prefixes="xs xsd">
		<xsl:apply-templates select="node()[local-name()!='import' and local-name()!='include']"/>
	</xsl:template>


	<!-- Dit template start de generatie van alle platgeslagen schema's. -->
	<xsl:template match="xs:schemaSet" mode="generateSchemas" exclude-result-prefixes="xs xsd">
		<xsl:variable name="namespace" select="@namespace"/>
		<xsl:choose>
			<!-- Volgende when dient voor het verwerken van een evt. rootSchema element. In een schemaSet met zo'n element moet dat element nl. 
				  altijd als ingang dienen voor het genereren van een nieuw schema. -->
			<xsl:when test="xs:rootSchema">
				<xsl:variable name="schemaFile">
					<xsl:call-template name="extractDirOrFileName">
						<xsl:with-param name="action" select="'extractFileName'"/>
						<xsl:with-param name="filePath" select="xs:rootSchema/@schemaLocation"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:variable name="schema" select="document(xs:rootSchema/@schemaLocation)"/>
				<xsl:variable name="newschema">
					<schema xmlns="http://www.w3.org/2001/XMLSchema">
						<!-- Eerst worden alle benodigde namespace declaraties gegenereerd. -->
						<xsl:for-each select="$schema//namespace::*">
							<xsl:if test="local-name()!='xs' and local-name()!='xsd'">
								<xsl:namespace name="{local-name()}" select="."/>
							</xsl:if>
						</xsl:for-each>
						<xsl:for-each select="xs:include">
							<xsl:variable name="includeSchema" select="document(@schemaLocation)"/>
							<xsl:for-each select="$includeSchema//namespace::*">
								<xsl:if test="local-name()!='xs' and local-name()!='xsd'">
									<xsl:namespace name="{local-name()}" select="."/>
								</xsl:if>
							</xsl:for-each>
						</xsl:for-each>
						<xsl:for-each select="//xs:schemaSet/xs:import[@importingNamespace=$namespace]">
							<xsl:variable name="importSchema" select="document(@schemaLocation)"/>
							<xsl:for-each select="$importSchema//namespace::*">
								<xsl:if test="local-name()!='xs' and local-name()!='xsd'">
									<xsl:namespace name="{local-name()}" select="."/>
								</xsl:if>
							</xsl:for-each>
						</xsl:for-each>
						<!-- Daarna worden alle attributen van het root element gerepliceerd. -->
						<xsl:apply-templates select="$schema/xs:schema/@*"/>
						<!-- Vervolgens worden er xs:import elementen gegenereerd voor all xs:import elementen die in de huidige namespace geimporteerd worden
							 (importingNamespace attribuut is gelijk aan de in bewerking zijnde namespace).. --> 
						<xsl:apply-templates select="//xs:schemaSet[xs:import/@importingNamespace=$namespace]"/>
						<!-- Dan worden alle elementen die geen include of import elementen zijn gerepliceerd. -->
						<xsl:apply-templates select="$schema/xs:schema/node()[local-name()!='import' and local-name()!='include']"/>
						<!-- Tenslotte wordt de inhoud van alle in de huidige schemaSet voorkomende schema bestanden waaraan wordt gerefereerd middels een 
							  xs:include of xs:import in het geconsolideerde schema gerepliceerd (op alle daar weer in voorkomende xs:include en xs:import elementen na). -->

						<!-- DEBUG: nagaan of hier niet een soortgelijke constructie moet komen als in regel 417 en 418. -->
						<xsl:apply-templates select="xs:include | xs:import" mode="resolve"/>				
					</schema>
				</xsl:variable>
				<xsl:result-document href="{concat('file:////',$applicationPath,'/consolidated/',$schemaFile)}" indent="yes" method="xml">
					<schema xmlns="http://www.w3.org/2001/XMLSchema">
						<!-- Eerst worden alle benodigde namespace declaraties gegenereerd. -->
						<xsl:for-each select="$newschema//namespace::*">
							<xsl:namespace name="{local-name()}" select="."/>
						</xsl:for-each>
						<!-- Daarna worden alle attributen van het root element gerepliceerd. -->
						<xsl:apply-templates select="$newschema/xs:schema/@*"/>
						<xsl:apply-templates select="$newschema/xs:schema/node()" mode="resolveRestrictions"/>
					</schema>
				</xsl:result-document>
			</xsl:when>
			<!-- Indien het xs:schemaSet slechts 1 kind bevat wordt de volgende when tak uitgevoerd. 
				  In dat geval behoud het bestand zijn naam en wordt de inhoud van het schema gerepliceerd. -->
			<xsl:when test="count(*)=1">
				<xsl:variable name="schemaFile">
					<xsl:call-template name="extractDirOrFileName">
						<xsl:with-param name="action" select="'extractFileName'"/>
						<xsl:with-param name="filePath" select="*/@schemaLocation"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:variable name="schema" select="document(*/@schemaLocation)"/>
				<xsl:variable name="newschema">
					<schema xmlns="http://www.w3.org/2001/XMLSchema">
						<!-- Eerst worden alle benodigde namespace declaraties gegenereerd. -->
						<xsl:for-each select="$schema//namespace::*">
							<xsl:if test="local-name()!='xs' and local-name()!='xsd'">
								<xsl:namespace name="{local-name()}" select="."/>
							</xsl:if>
						</xsl:for-each>
						<!-- Daarna worden alle attributen van het root element gerepliceerd. -->
						<xsl:apply-templates select="$schema/xs:schema/@*"/>
						<!-- Vervolgens worden er xs:import elementen gegenereerd voor all xs:import elementen die in de huidige namespace geimporteerd worden
							 (importingNamespace attribuut is gelijk aan de in bewerking zijnde namespace).. --> 
						<xsl:apply-templates select="//xs:schemaSet[xs:import/@importingNamespace=$namespace]"/>
						<!-- Dan worden alle elementen die geen include of import elementen zijn gerepliceerd. 
							   DEBUG: In principe zou hier niet gecheckt hoeven te worden op local-name()!='include' aangezien er in deze namespace slechts 1 bestand 
							   voorkomt en er daardoor ook geen sprake kan zijn van een include. Wellicht nog verwijderen! -->
						<xsl:apply-templates select="$schema/xs:schema/node()[local-name()!='import' and local-name()!='include']"/>				
						<!-- Hier wordt niet op xs:import en xs:include elementen gecheckt er komt immers maar 1 schema voor in deze namespace. -->
					</schema>
				</xsl:variable>
				<xsl:result-document href="{concat('file:////',$applicationPath,'/consolidated/',$schemaFile)}" indent="yes" method="xml">
					<schema xmlns="http://www.w3.org/2001/XMLSchema">
						<!-- Eerst worden alle benodigde namespace declaraties gegenereerd. -->
						<xsl:for-each select="$newschema//namespace::*">
							<xsl:namespace name="{local-name()}" select="."/>
						</xsl:for-each>
						<!-- Daarna worden alle attributen van het root element gerepliceerd. -->
						<xsl:apply-templates select="$newschema/xs:schema/@*"/>
						<xsl:apply-templates select="$newschema/xs:schema/node()" mode="resolveRestrictions"/>
					</schema>
				</xsl:result-document>
			</xsl:when>
			<!-- In alle andere gevallen (als de schemaSet geen rootSchema bevat maar wel meerdere entries) dan wordt deze otherwise tak gebruikt. -->
			<xsl:otherwise>
				<xsl:variable name="firstSchemaId" select="generate-id(*[1])"/>
				<xsl:variable name="schemaFile">
					<xsl:call-template name="extractDirOrFileName">
						<xsl:with-param name="action" select="'extractFileName'"/>
						<xsl:with-param name="filePath" select="*[1]/@schemaLocation"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:variable name="schema" select="document(*[1]/@schemaLocation)"/>
				<xsl:variable name="newschema">
					<schema xmlns="http://www.w3.org/2001/XMLSchema">
						<!-- Eerst worden alle benodigde namespace declaraties gegenereerd. -->
						<xsl:for-each select="$schema//namespace::*">
							<xsl:if test="local-name()!='xs' and local-name()!='xsd'">
								<xsl:namespace name="{local-name()}" select="."/>
							</xsl:if>
						</xsl:for-each>
						<xsl:for-each select="xs:include | xs:import">
							<xsl:variable name="includeSchema" select="document(@schemaLocation)"/>
							<xsl:for-each select="$includeSchema//namespace::*">
								<xsl:if test="local-name()!='xs' and local-name()!='xsd'">
									<xsl:namespace name="{local-name()}" select="."/>
								</xsl:if>
							</xsl:for-each>
						</xsl:for-each>
						<!-- Daarna worden alle attributen van het root element gerepliceerd. -->
						<xsl:apply-templates select="$schema/xs:schema/@*"/>
						<!-- Vervolgens worden er xs:import elementen gegenereerd voor all xs:import elementen die in de huidige namespace geimporteerd worden
							 (importingNamespace attribuut is gelijk aan de in bewerking zijnde namespace).. --> 
						<xsl:apply-templates select="//xs:schemaSet[xs:import/@importingNamespace=$namespace]"/>
						<!-- Dan worden alle elementen die geen include of import elementen zijn gerepliceerd. -->
						<xsl:apply-templates select="$schema/xs:schema/node()[local-name()!='import' and local-name()!='include']"/>
						<!-- Tenslotte wordt de inhoud van alle in de huidige schemaSet voorkomende schema bestanden waaraan wordt gerefereerd middels een 
							  xs:include of xs:import in het geconsolideerde schema gerepliceerd (op alle daar weer in voorkomende xs:include en xs:import elementen na). -->
						<xsl:apply-templates select="xs:include[generate-id()!=$firstSchemaId and not(@schemaLocation=preceding-sibling::xs:import/@schemaLocation) and not(@schemaLocation=preceding-sibling::xs:include/@schemaLocation)]" mode="resolve"/>				
						<xsl:apply-templates select="xs:import[generate-id()!=$firstSchemaId and not(@schemaLocation=preceding-sibling::xs:import/@schemaLocation) and not(@schemaLocation=preceding-sibling::xs:include/@schemaLocation)]" mode="resolve"/>
					</schema>
				</xsl:variable>
				<xsl:result-document href="{concat('file:////',$applicationPath,'/consolidated/',$schemaFile)}" indent="yes" method="xml">
					<schema xmlns="http://www.w3.org/2001/XMLSchema">
						<!-- Eerst worden alle benodigde namespace declaraties gegenereerd. -->
						<xsl:for-each select="$newschema//namespace::*">
							<xsl:namespace name="{local-name()}" select="."/>
						</xsl:for-each>
						<!-- Daarna worden alle attributen van het root element gerepliceerd. -->
						<xsl:apply-templates select="$newschema/xs:schema/@*"/>
						<xsl:apply-templates select="$newschema/xs:schema/node()" mode="resolveRestrictions"/>
					</schema>
				</xsl:result-document>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Het volgende template zorgt er voor dat alle relevante xs:import element in het te genereren schema gerepliceerd worden. -->
	<xsl:template match="xs:schemaSet" exclude-result-prefixes="xs xsd">
		<xsl:apply-templates select="xs:import" mode="replicate"/>
	</xsl:template>
	
	<!-- Het volgende template plaatst alle geconsolideerde schema's bij elkaar in 1 bestand. 
		  Elk 'schema' element wordt daarbij binnen een 'mySchema' element geplaatst met daarbij een 'path' attribuut met als waarde het path waarop het uiteindelijke schema bewaard moet worden. -->
	<xsl:template match="xs:schemaSet" mode="generateConsolidatedSchemaSet">
				<xsl:choose>
			<!-- Volgende when dient voor het verwerken van een evt. rootSchema element. In een schemaSet met zo'n element moet dat element nl. 
				  altijd als ingang dienen voor het genereren van een nieuw schema. -->
			<xsl:when test="xs:rootSchema">
				<xsl:variable name="schemaFile">
					<xsl:call-template name="extractDirOrFileName">
						<xsl:with-param name="action" select="'extractFileName'"/>
						<xsl:with-param name="filePath" select="xs:rootSchema/@schemaLocation"/>
					</xsl:call-template>
				</xsl:variable>
				<xs:mySchema path="{concat('file:////',$applicationPath,'/finalized/',$schemaFile)}">
					<xsl:copy-of select="document(concat('file:////',$applicationPath,'/consolidated/',$schemaFile))"/>
				</xs:mySchema>
			</xsl:when>
			<!-- Indien het xs:schemaSet slechts 1 kind bevat wordt de volgende when tak uitgevoerd. 
				  In dat geval behoud het bestand zijn naam en wordt de inhoud van het schema gerepliceerd. -->
			<xsl:when test="count(*)=1">
				<xsl:variable name="schemaFile">
					<xsl:call-template name="extractDirOrFileName">
						<xsl:with-param name="action" select="'extractFileName'"/>
						<xsl:with-param name="filePath" select="*/@schemaLocation"/>
					</xsl:call-template>
				</xsl:variable>
				<xs:mySchema path="{concat('file:////',$applicationPath,'/finalized/',$schemaFile)}">
					<xsl:copy-of select="document(concat('file:////',$applicationPath,'/consolidated/',$schemaFile))"/>
				</xs:mySchema>
			</xsl:when>
			<!-- In alle andere gevallen (als de schemaSet geen rootSchema bevat maar wel meerdere entries) dan wordt deze otherwise tak gebruikt. -->
			<xsl:otherwise>
				<xsl:variable name="schemaFile">
					<xsl:call-template name="extractDirOrFileName">
						<xsl:with-param name="action" select="'extractFileName'"/>
						<xsl:with-param name="filePath" select="*[1]/@schemaLocation"/>
					</xsl:call-template>
				</xsl:variable>
				<xs:mySchema path="{concat('file:////',$applicationPath,'/finalized/',$schemaFile)}">
					<xsl:copy-of select="document(concat('file:////',$applicationPath,'/consolidated/',$schemaFile))"/>
				</xs:mySchema>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- Dit template reproduceert het xs:rootSchema element. -->
	<xsl:template match="xs:rootSchema" mode="indicateProcessed" exclude-result-prefixes="fn schemaReferences xs xsd">
			<rootSchema>
				<xsl:apply-templates select="@*"/>
			</rootSchema>
	</xsl:template>	

	
	<!-- Dit template reproduceert een xs:include element en voegt daar het processed attribuut met de waarde yes aan toe. -->
	<xsl:template match="xs:include|xs:import" mode="indicateProcessed" exclude-result-prefixes="fn schemaReferences xs xsd">
			<xsl:copy>
				<xsl:apply-templates select="@*"/>
				<xsl:if test="not(@processed='yes')">
					<xsl:attribute name="processed" select="'yes'"/>
				</xsl:if>
			</xsl:copy>
	</xsl:template>
	
	<!-- Dit schema wordt gebruikt om de xs:include en xs:import elementen die in de diverse schema's staan op te nemen in de schemaList bestanden.
		  Het genereert voor elk gevonden xs:include of xs:import element een placeholder. 
		  Voor elk gevonden xs:import element wordt tevens vastgelegd in welke namespace ze geimporteerd moeten worden.-->
	<xsl:template match="xs:include|xs:import" exclude-result-prefixes="fn schemaReferences xs xsd" mode="buildListOfImportsOrIncludes">
		<xsl:param name="path"/>
		<xsl:variable name="schemaPath"><xsl:value-of select="concat($path,'/',@schemaLocation)"/></xsl:variable>
		<xsl:variable name="newPath">
			<xsl:call-template name="extractDirOrFileName">
				<xsl:with-param name="action" select="'extractDir'"/>
				<xsl:with-param name="filePath" select="$schemaPath"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="schemaFile">
			<xsl:call-template name="extractDirOrFileName">
				<xsl:with-param name="action" select="'extractFileName'"/>
				<xsl:with-param name="filePath" select="$schemaPath"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="local-name()='include'">
				<include>
					<xsl:attribute name="schemaLocation" select="concat($newPath,'/',$schemaFile)"/>
					<xsl:attribute name="namespace" select="//@targetNamespace"/>
					<xsl:attribute name="processed" select="'no'"/>
				</include>
			</xsl:when>
			<xsl:otherwise>
				<import>
					<xsl:attribute name="schemaLocation" select="concat($newPath,'/',$schemaFile)"/>
					<xsl:attribute name="importingNamespace" select="//@targetNamespace"/>
					<xsl:attribute name="namespace" select="@namespace"/>
					<xsl:attribute name="processed" select="'no'"/>
				</import>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Dit template verwerkt de xml-schema bestanden waaraan d.m.v. xs:include elementen wordt gerefereerd. -->
	<xsl:template match="xs:include|xs:import" mode="processIncludes" exclude-result-prefixes="fn schemaReferences xs xsd">
		<xsl:variable name="schemaPath"><xsl:value-of select="@schemaLocation"/></xsl:variable>
		<xsl:variable name="document" select="document($schemaPath)"/>
		<xsl:variable name="path">
			<xsl:call-template name="extractDirOrFileName">
				<xsl:with-param name="action" select="'extractDir'"/>
				<xsl:with-param name="filePath" select="$schemaPath"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:apply-templates select="$document/xs:schema/xs:include" mode="buildListOfImportsOrIncludes">
			<xsl:with-param name="path" select="$path"/>
		</xsl:apply-templates>
		<xsl:apply-templates select="$document/xs:schema/xs:import" mode="buildListOfImportsOrIncludes">
			<xsl:with-param name="path" select="$path"/>
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="xs:include|xs:import" mode="resolve" exclude-result-prefixes="xs xsd">
		<xsl:variable name="schema" select="document(@schemaLocation)"/>
		<xsl:apply-templates select="$schema/xs:schema" mode="include"/>
	</xsl:template>


	<!-- Template reproduceert het xs:import element indien er geen xs:import element binnen het xs:schemaSet bestaat met dezelfde waarde voor het namespace 
		   attribuut wat voor dit xs:import element staat. De waarde van het schemaLocation attribuut wordt hierbij evt. ontdaan van een path.
		   Het bevat dus alleen een bestandsnaam.  -->
	<xsl:template match="xs:import" mode="replicate" exclude-result-prefixes="xs xsd">
		<xsl:variable name="namespace" select="@namespace"/>
		<xsl:if test="not(preceding-sibling::xs:import[@namespace=$namespace])">
			<xsl:variable name="schemaFile">
				<xsl:choose>
					<xsl:when test="contains(@schemaLocation,'/') or contains(@schemaLocation,'\')">
						<xsl:call-template name="extractDirOrFileName">
							<xsl:with-param name="action" select="'extractFileName'"/>
							<xsl:with-param name="filePath" select="@schemaLocation"/>
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise><xsl:value-of select="@schemaLocation"/></xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<import schemaLocation="{$schemaFile}">
				<xsl:apply-templates select="@namespace"/>
			</import>
		</xsl:if>
	</xsl:template>


	<!-- Volgende templates worden gebruikt om elementen die niet in dit stylesheet zijn opgenomen en evt. diepere structuren te repliceren. -->
	<xsl:template match="@*|node()" exclude-result-prefixes="xs xsd">
		<xsl:copy copy-namespaces="no" exclude-result-prefixes="xs xsd">
			<xsl:apply-templates select="@*|node()"/>
		</xsl:copy>
	</xsl:template>

	<xsl:template match="@*|node()" exclude-result-prefixes="xs xsd" mode="resolveRestrictions">
		<xsl:copy copy-namespaces="no" exclude-result-prefixes="xs xsd">
			<xsl:apply-templates select="@*|node()" mode="resolveRestrictions"/>
		</xsl:copy>
	</xsl:template>




	<!-- Het volgende template genereert voor elk 'complexType' element onder het 'schema' niveau een recursieve structuur van complexTypes die op elkaar gebaseerd zijn.
		  Zodra in deze structuur een complexType wordt gebruikt waarvan het laatste deel van de naam niet uit '-basis' bestaat wordt een 'stop' element ingevoegd. 
		  Dat betekend dat de bovenliggende complexType(s) niet uit de schema's verwijderd mogen worden. -->
	<xsl:template match="xs:complexType" mode="getPath">
		<xsl:param name="path"/>
		<xsl:variable name="namespace" select="ancestor::xs:schema/@targetNamespace"/>
		<xsl:variable name="complexTypeName" select="@name"/>
		<xsl:if test="not(contains($path,concat(';',$complexTypeName,';')))">
			<complexType name="{$complexTypeName}" namespace="{$namespace}">
				<xsl:choose>
					<xsl:when test="key('complexType',$complexTypeName) and not(contains(@name,'-basis'))">
						<stop/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="key('complexType',$complexTypeName)" mode="getPath">
							<xsl:with-param name="path" select="concat($path,';',$complexTypeName,';')"/>
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			</complexType>
		</xsl:if>
	</xsl:template>

	<!-- Dit template reproduceert een xs:div element. -->
	<xsl:template match="xs:div" mode="indicateProcessed" exclude-result-prefixes="fn schemaReferences xs xsd">
			<div/>
	</xsl:template>

	<xsl:template match="xs:complexContent[xs:restriction and $restrictionMode='true' and /xs:schema/@targetNamespace!=$doNotResolve//application:namespace]" 
						exclude-result-prefixes="xs xsd" mode="resolveRestrictions">
		<xsl:apply-templates mode="resolveRestrictions"/>
	</xsl:template>
	
	<xsl:template match="xs:simpleContent[xs:restriction[(xs:attribute or xs:attributeGroup) and not(*[name()!='xs:attribute']) and not(*[name()!='xs:attributeGroup'])] and $restrictionMode='true' and /xs:schema/@targetNamespace!=$doNotResolve//application:namespace]" 
						exclude-result-prefixes="xs xsd" mode="resolveRestrictions">
		<xsl:copy>
			<xsl:apply-templates mode="resolveRestrictions"/>
		</xsl:copy>
	</xsl:template>
	
	<!-- Zorgt er voor dat een evt. hoger niveau xs:complexType ook wordt verwerkt. -->
	<xsl:template match="xs:extension|xs:restriction" exclude-result-prefixes="xs xsd" mode="resolveAttributes">
		<xsl:param name="schemaList"/>
		<xsl:call-template name="resolveAttributes">
			<xsl:with-param name="base" select="substring-after(@base,':')"/>
			<xsl:with-param name="schemaList" select="$schemaList"/>
		</xsl:call-template>
	</xsl:template>

	<xsl:template match="xs:restriction[parent::xs:simpleContent and $restrictionMode='true' and /xs:schema/@targetNamespace!=$doNotResolve//application:namespace]" 
						exclude-result-prefixes="xs xsd" mode="resolveRestrictions">
		<!-- Deze variabele is nodig om de evt. 'xs:attributeGroup' elementen op te kunnen halen. -->
		<xsl:variable name="schemaList" select="doc(concat('file:////',$applicationPath,'/generated/schemaList.xml'))"/>
		<!-- In dit deel wordt de lijst met attributen opgebouwd. De meest van toepassing zijnde attributen staan daarbij vooraan.
			  Indien de ancestor 'complexType' andere elementen dan 'xs:restriction' of 'xs:extension' bevaten dan wordt een 'stop' element gegenereerd.	
			  Indien deze  'xs:restriction' of 'xs:extension' elementen op hun beurt andere elementen dan 'xs:attribute' bevatten dan worden deze ook gerepliceerd.
			  Namespaces op het 'groups' element zijn noodzakelijk om in staat te zijn de gewenste schema's op te halen. -->
		<xsl:variable name="children">
			<groups>
				<xsl:for-each select="namespace::*">
					<xsl:namespace name="{local-name()}" select="."/>
				</xsl:for-each>
				<xsl:apply-templates select="*[name()!='xs:attributeGroup']"/>
				<xsl:apply-templates select="xs:attributeGroup" mode="resolveAttributes">
					<xsl:with-param name="schemaList" select="$schemaList"/>
				</xsl:apply-templates>
				<xsl:call-template name="resolveChildren">
					<xsl:with-param name="base" select="substring-after(@base,':')"/>
					<xsl:with-param name="schemaList" select="$schemaList"/>
				</xsl:call-template>
			</groups>
		</xsl:variable>
		<!-- In de volgende choose wordt de beslissing genomen om of de gehele 'xs:restriction' tree te repliceren of om deze om te bouwen naar een 'xs:extension' structuur. 
			  Dit is afhankelijk van het voorkomen van andere elementen dan 'attribute' en 'xs:extensionBase'. -->
		<xsl:choose>
			<xsl:when test="$children/xs:groups/*[name()!='attribute' and name()!='xs:extensionBase']">
				<xsl:copy>
					<xsl:apply-templates select="@* | node()"/>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<extension base="{$children//xs:extensionBase}">
					<xsl:for-each select="$children//xs:attribute">
						<xsl:variable name="name" select="@name"/>
						<xsl:variable name="ref" select="@ref"/>
						<xsl:if test="not(preceding-sibling::xs:attribute[@ref = $ref]) and not(preceding-sibling::xs:attribute[@name = $name])">
							<xsl:choose>
								<xsl:when test="@use='prohibited'"/>
								<xsl:otherwise>
									<xsl:copy exclude-result-prefixes="xs xsd">
										<xsl:apply-templates select="@*"/>
									</xsl:copy>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:if>
					</xsl:for-each>
				</extension>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template match="xs:restriction[parent::xs:complexContent and $restrictionMode='true' and /xs:schema/@targetNamespace!=$doNotResolve//application:namespace]" 
						exclude-result-prefixes="xs xsd" mode="resolveRestrictions">
		<!-- Eerst worden de 'xs:element' elementen geresolved. -->
		<xsl:apply-templates select="*[local-name()!='attribute' and local-name()!='attributeGroup']"/>
		<!-- Daarna de attributen. Dit is echter wat bewerkelijker omdat de attributen niet herhaald hoeven te worden om toegekend te kunnen worden. 
			  Daarom wordt eerst een lijst van attributen opgebouwd die in de huidige complexType en in al diens voorouders voorkomen.
			  Als extra complexiteit dienen hierin ook nog de 'xs:attributeGroup' elementen meegenomen worden en de 'xs:attribute' elementen daarvan opgehaald worden.
			  Extra complex omdat deze ook in andere namespaces voor kunnen komen en du sin andere schema's gecheckt moeten worden.
			  
			  De zo verkregen lijst moet worden doorgelopen en van duplicaten worden ontdaan. Daarbij is het attribuut dat op het laagste level is gedefinieerd van toepassing.
			  Tenslotte moeten ook alleen die attributen geplaatst worden die niet de status prohibited hebben op het huidige complexType of op diens voorouders).
			   -->
		<!-- Deze variabele is nodig om de evt. 'xs:attributeGroup' elementen op te kunnen halen. -->
		<xsl:variable name="schemaList" select="doc(concat('file:////',$applicationPath,'/generated/schemaList.xml'))"/>
		<!-- In dit deel wordt de lijst met attributen opgebouwd. De meest van toepassing zijnde attributen staan daarbij vooraan.
			  Namespaces op het 'groups' element zijn noodzakelijk om in staat te zijn de gewenste schema's op te halen. -->
		<xsl:variable name="attributes">
			<groups>
				<xsl:for-each select="namespace::*">
					<xsl:namespace name="{local-name()}" select="."/>
				</xsl:for-each>
					<xsl:apply-templates select="xs:attribute"/>
					<xsl:apply-templates select="xs:attributeGroup" mode="resolveAttributes">
						<xsl:with-param name="schemaList" select="$schemaList"/>
					</xsl:apply-templates>
				<xsl:call-template name="resolveAttributes">
					<xsl:with-param name="base" select="substring-after(@base,':')"/>
					<xsl:with-param name="schemaList" select="$schemaList"/>
				</xsl:call-template>
			</groups>
		</xsl:variable>
		<!-- Hieronder wordt de lijst met attributen ontdaan van dubbelen en van attributen die prohibited zijn. -->
		<xsl:for-each select="$attributes//xs:attribute">
			<xsl:variable name="name" select="@name"/>
			<xsl:variable name="ref" select="@ref"/>
			<xsl:if test="not(preceding-sibling::xs:attribute[@ref = $ref]) and not(preceding-sibling::xs:attribute[@name = $name])">
				<xsl:choose>
					<xsl:when test="@use='prohibited'"/>
					<xsl:otherwise>
						<xsl:copy exclude-result-prefixes="xs xsd">
							<xsl:apply-templates select="@*"/>
						</xsl:copy>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

	<!-- Volgende template start de verwerking van kinderen van xs:simpleContent elementen. -->
	<xsl:template name="resolveChildren">
		<xsl:param name="base"/>
		<xsl:param name="schemaList"/>
		<!-- Volgende choose zorgt voor afhandeling van 3 situaties:
			  * Indien het 'xs:simpleContent' element een 'xs:extension' element heeft dan worden alle kinderen gerepliceerd.
				Eventuele 'xs:attributeGroup' elementen worden geresolved naar 'xs:attribute' elementen verder wordt er een 'xs:extensionBase' element gegenereerd
				met als waarde de waarde van het 'base' attribuut van het 'xs:extension' element.
			  * Indien het 'xs:simpleContent' element een 'xs:restriction' element heeft dan worden alle kinderen gerepliceerd.
				Eventuele 'xs:attributeGroup' elementen worden geresolved naar 'xs:attribute' elementen.
				Tenslotte wordt het 'resolveChildren' template gestart voor de verwerking van het volgende level 'xs:complexType'.
			  * In alle andere gevallen wordt er een 'stop' element gegenereerd. -->
		<xsl:choose>
			<xsl:when test="//xs:complexType[@name=$base]/xs:simpleContent/xs:extension">
				<xs:extensionBase><xsl:value-of select="//xs:complexType[@name=$base]/xs:simpleContent/xs:extension/@base"/></xs:extensionBase>
				<xsl:apply-templates select="//xs:complexType[@name=$base]/xs:simpleContent/xs:extension/*[name()!='xs:attributeGroup']"/>
				<xsl:apply-templates select="//xs:complexType[@name=$base]/xs:simpleContent/xs:extension/xs:attributeGroup" mode="resolveAttributes">
					<xsl:with-param name="schemaList" select="$schemaList"/>
				</xsl:apply-templates>
			</xsl:when>
			<xsl:when test="//xs:complexType[@name=$base]/xs:simpleContent/xs:restriction">
				<xsl:apply-templates select="//xs:complexType[@name=$base]/xs:simpleContent/xs:restriction/*[name()!='xs:attributeGroup']"/>
				<xsl:apply-templates select="//xs:complexType[@name=$base]/xs:simpleContent/xs:restriction/xs:attributeGroup" mode="resolveAttributes">
					<xsl:with-param name="schemaList" select="$schemaList"/>
				</xsl:apply-templates>
				<xsl:call-template name="resolveChildren">
					<xsl:with-param name="base" select="substring-after(//xs:complexType[@name=$base]/xs:simpleContent/xs:restriction/@base,':')"/>
					<xsl:with-param name="schemaList" select="$schemaList"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<stop/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Volgende template start de verwerking van xs:attribute elementen in het eerst hogere xs:complexType element. -->
	<xsl:template name="resolveAttributes">
		<xsl:param name="base"/>
		<xsl:param name="schemaList"/>
		<!-- Volgende twee apply-templates dragen zorg voor het plaatsen van de xs:attribute elementen binnen dit level in de lijst met attribute elementen. -->
		<xsl:apply-templates select="//xs:complexType[@name=$base]//xs:attribute"/>
		<xsl:apply-templates select="//xs:complexType[@name=$base]//xs:attributeGroup" mode="resolveAttributes">
			<xsl:with-param name="schemaList" select="$schemaList"/>
		</xsl:apply-templates>
		<xsl:apply-templates select="//xs:complexType[@name=$base]//xs:extension" mode="resolveAttributes">
			<xsl:with-param name="schemaList" select="$schemaList"/>
		</xsl:apply-templates>
		<xsl:apply-templates select="//xs:complexType[@name=$base]//xs:restriction" mode="resolveAttributes">
			<xsl:with-param name="schemaList" select="$schemaList"/>
		</xsl:apply-templates>
	</xsl:template>

	<!-- Zorgt voor het ophalen van xs:attribute elementen binnen een xs:attributeGroup element in een ander schema. -->
	<xsl:template match="xs:attributeGroup" mode="resolveAttributes">
		<xsl:param name="schemaList"/>
		<xsl:variable name="name" select="substring-after(@ref,':')"/>
		<xsl:variable name="prefix" select="substring-before(@ref,':')"/>
		<xsl:variable name="attGrpNamespace" select="namespace::*[name()=$prefix]"/>
		<xsl:for-each select="$schemaList//xs:schemaSet[@namespace=$attGrpNamespace]/*">		
			<xsl:variable name="schema" select="doc(@schemaLocation)"/>
			<xsl:apply-templates select="$schema//xs:attributeGroup[@name=$name]//xs:attribute"/>
			<xsl:apply-templates select="$schema//xs:attributeGroup[@name=$name]//xs:attributeGroup" mode="resolveAttributes">
				<xsl:with-param name="schemaList" select="$schemaList"/>
			</xsl:apply-templates>
		</xsl:for-each>
	</xsl:template>

	
	<!--	****************************************************************************************************************
			Functie templates
			****************************************************************************************************************-->

	<!-- Dit template dient om een filenaam of een absoluut path zonder filenaam te extraheren
			Parameters:
			action:		Bevat de uit te voeren actie.
							'extractDir' betekend dat een path zonder filenaam uit het opgegeven path wordt geextraheerd.
							'extractFileName' betekend dat de filenaam uit het opgegeven path wordt geextraheerd.
			filePath:	Bevat het path waarop de gewenste actie moet worden uitgevoerd.
			 
			Output van deze functie is een filenaam of een path niet eindigend op een '/'.-->
	<xsl:template name="extractDirOrFileName" exclude-result-prefixes="xs xsd">
		<xsl:param name="action"/>
		<xsl:param name="filePath"/>
		<xsl:param name="filePathWithoutFileName" select="''"/>
		<xsl:choose>
			<xsl:when test="contains(substring-after($filePath,'/'),'/')">
				<xsl:call-template name="extractDirOrFileName">
					<xsl:with-param name="action" select="$action"/>
					<xsl:with-param name="filePath" select="substring-after($filePath,'/')"/>
					<xsl:with-param name="filePathWithoutFileName" select="concat($filePathWithoutFileName,substring-before($filePath,'/'),'/')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="$action='extractDir'">
						<xsl:call-template name="transformRelative2AbsolutePath">
							<xsl:with-param name="filePathOrRemainder" select="concat($filePathWithoutFileName,substring-before($filePath,'/'))"/>
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$action='extractFileName'">
						<xsl:value-of select="substring-after($filePath,'/')"/>
					</xsl:when>				
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="constructRelativePath" exclude-result-prefixes="xs xsd">
		<xsl:param name="path"/>
		<xsl:param name="schemaLocation"/>
		<xsl:choose>
			<xsl:when test="contains($schemaLocation,$path)">
				<xsl:value-of select="substring-after($schemaLocation,concat($path,'/'))"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:variable name="commonPart">
					<xsl:call-template name="constructCommonPart">
						<xsl:with-param name="schemaLocation" select="$schemaLocation"/>
						<xsl:with-param name="path" select="$path"/>
						<xsl:with-param name="commonPart" select="substring-before($path,'/')"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:variable name="fixedPart" select="substring-after($schemaLocation,concat($commonPart,'/'))"/>
				<xsl:variable name="relativePart">
					<xsl:call-template name="constructRelativePart">
						<xsl:with-param name="Part2BConverted" select="substring-after($path,concat($commonPart,'/'))"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:value-of select="concat($relativePart,$fixedPart)"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="constructRelativePart" exclude-result-prefixes="xs xsd">
		<xsl:param name="Part2BConverted"/>
		<xsl:param name="relativePart" select="''"/>
		<xsl:choose>
			<xsl:when test="contains($Part2BConverted,'/')">
				<xsl:call-template name="constructRelativePart">
					<xsl:with-param name="Part2BConverted" select="substring-after($Part2BConverted,'/')"/>
					<xsl:with-param name="relativePart" select="concat($relativePart,'../')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise><xsl:value-of select="concat($relativePart,'../')"/></xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="constructCommonPart" exclude-result-prefixes="xs xsd">
		<xsl:param name="schemaLocation"/>
		<xsl:param name="path"/>
		<xsl:param name="commonPart"/>
		<xsl:choose>
			<xsl:when test="not(contains($schemaLocation,concat($commonPart,'/',substring-before(substring-after($path,concat($commonPart,'/')),'/'))))">
				<xsl:value-of select="$commonPart"/>
			</xsl:when>
			<xsl:when test="substring-before(substring-after($path,concat($commonPart,'/')),'/')=''">
				<xsl:value-of select="$commonPart"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="constructCommonPart">
					<xsl:with-param name="schemaLocation" select="$schemaLocation"/>
					<xsl:with-param name="path" select="$path"/>
					<xsl:with-param name="commonPart" select="concat($commonPart,'/',substring-before(substring-after($path,concat($commonPart,'/')),'/'))"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Onderstaande templates dienen om een path zodanig op te schonen dat alle evt. '/..' strings uit het pad verwijderd worden waarbij het pad toch correct blijft.
	
		Parameters:
		filePathOrRemainder:		Bevat het path dat naar een absoluut path omgezet moet worden.
											In het path moeten vooraf natuurlijk wel alle '\' omgezet worden naar '/'. 
		filePathRemainderPart1:	Bevat het reeds verwerkte deel van het path. In de initiele aanroep hoeft deze paramter niet meegenomen te worden.
		
		Output van deze functie is een correct path waarin alle '/..' verwijderd zijn.-->
	 
	<xsl:template name="transformRelative2AbsolutePath" exclude-result-prefixes="xs xsd">
		<xsl:param name="filePathOrRemainder"/>
		<xsl:param name="filePathRemainderPart1" select="''"/>
		<xsl:choose>
			<xsl:when test="contains($filePathOrRemainder,'/..')">
				<xsl:variable name="Part1">
					<xsl:call-template name="cleanPart1">
						<xsl:with-param name="Part1" select="concat($filePathRemainderPart1,substring-before($filePathOrRemainder,'/..'))"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:call-template name="transformRelative2AbsolutePath">
					<xsl:with-param name="filePathOrRemainder" select="substring-after($filePathOrRemainder,'/..')"/>
					<xsl:with-param name="filePathRemainderPart1" select="$Part1"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="concat($filePathRemainderPart1,$filePathOrRemainder)"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--Daadwerkelijke verwijdering van de '/..' string vindt in dit template plaats. -->
	<xsl:template name="cleanPart1" exclude-result-prefixes="xs xsd">
		<xsl:param name="Part1"/> 
		<xsl:param name="Part1a" select="''"/>
		<xsl:choose>
			<xsl:when test="contains($Part1,'/')">
				<xsl:call-template name="cleanPart1">
					<xsl:with-param name="Part1" select="substring-after($Part1,'/')"/>
					<xsl:with-param name="Part1a" select="concat(translate(translate($Part1a,'#','/'),'//','/'),substring-before($Part1,'/'),'#')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="contains($Part1a,'#')">
				<xsl:value-of select="substring-before($Part1a,'#')"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$Part1a"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>